      program c_ainv02

c     In c_ainv02, the inverse of a numerator relationship
c     matrix A^(-1) is calculated (the current version can
c     deal with a much larger-sized data set than c_ainv01).

      parameter(mx_ind=500000)

c     Considering N as the order of A^(-1), the number of
c     non-zero elements in A^(-1) can be a maximum of 4*N.
c     (half-stored).

      integer tvis1,tvis2,tvis3,tvis4,tvis5,id(mx_ind,2)
     >       ,tvim1(0:4*mx_ind,2),tvim2(4*mx_ind,2)
      real*8 tvds,dinv_d(mx_ind),tvdm(4*mx_ind)
      open(99,file='pdgr.txt')
      open(98,file='coeF.txt')
*     open(97,file='pdgr1.out')
      open(97,file='pdgr2.out')
      open(96,file='pdgr3.out')
*     open(94,file='pdgr4.out')

      nr_ind=1
1     read(99,*,end=2) id(nr_ind,1),id(nr_ind,2)
      nr_ind=nr_ind+1
      goto 1
2     continue
      nr_ind=nr_ind-1

      do i=1,nr_ind
       read(98,*) dinv_d(i)  ! dinv_d means diagonal
      enddo                  ! elements in D^(-1).
      do i=nr_ind,1,-1
       if(id(i,1).ne.0.and.id(i,2).ne.0) then  ! Non-founder
        dinv_d(i)=1.d0/sqrt(.5d0-.25d0
     >           *(dinv_d(id(i,1))+dinv_d(id(i,2))))
       elseif(id(i,1).lt.1.and.id(i,2).lt.1) then  ! Founder
        dinv_d(i)=1.d0
       else  ! Half-founder
        if(id(i,1).ne.0) dinv_d(i)=1.d0/sqrt(.75d0-.25d0
     >                            *dinv_d(id(i,2)))
        if(id(i,2).ne.0) dinv_d(i)=1.d0/sqrt(.75d0-.25d0
     >                            *dinv_d(id(i,1)))
       endif
      enddo

      tvim1(0,1)=mx_ind+1
      do i=1,nr_ind
       tvim1(i,1)=i
       tvim1(i,2)=0
      enddo
      tvis1=0

      do i=nr_ind,1,-1
       do j=1,2
        if(id(i,j).lt.1) goto 3
        if(abs(id(i,1)-id(i,2)).lt.1.and.j.ne.1) goto 3
        tvis1=tvis1+1
        tvim1(nr_ind+tvis1,1)=i
        tvim1(nr_ind+tvis1,2)=tvim1(id(i,j),2)
        tvim1(id(i,j),2)=nr_ind+tvis1
3       continue
       enddo
      enddo

      do i=nr_ind,1,-1
       if(id(i,1).ne.0.and.id(i,2).ne.0) then
        do j=1,2
         if(id(i,3-j).gt.id(i,j)) then
          tvis2=id(i,j)
          tvis3=tvim1(id(i,j),2)
          do while(tvim1(tvis3,1).lt.id(i,3-j))
           tvis2=tvis3
           tvis3=tvim1(tvis3,2)
          enddo
          if(tvim1(tvis3,1).ne.id(i,3-j)) then
           tvis1=tvis1+1
           tvim1(nr_ind+tvis1,1)=id(i,3-j)
           tvim1(nr_ind+tvis1,2)=tvis3
           tvim1(tvis2,2)=nr_ind+tvis1
          endif
         endif
        enddo
       endif
      enddo

      do i=1,nr_ind

c     The diagonal element (i, i) of A^(-1) is calculated.

       tvds=dinv_d(i)**2
       tvis1=tvim1(i,2)
       do while(tvis1.ne.0)
        j=tvim1(tvis1,1)
        if(id(j,1).ne.i.and.id(j,2).ne.i) goto 4
        if(id(j,1).ne.id(j,2)) then
         tvds=tvds+(-.5d0*dinv_d(j))**2
        else
         tvds=tvds+dinv_d(j)**2
        endif
4       tvis1=tvim1(tvis1,2)
       enddo
       write(97,'(2i8,f16.8)') i,i,tvds

c     The off-diagonal element (i, j) of A^(-1) is
c     calculated.

       tvis1=tvim1(i,2)
       do while(tvis1.ne.0)
        j=tvim1(tvis1,1)
        tvds=.0d0

        tvis2=tvim1(i,2)
        tvis3=j
        do while(tvis2.ne.0)
         tvis4=tvim1(tvis2,1)
         if(id(tvis4,1).ne.i.and.id(tvis4,2).ne.i) goto 5
         do while(tvim1(tvis3,1).lt.tvis4)
          tvis3=tvim1(tvis3,2)
         enddo
         tvis5=tvim1(tvis3,1)
         if(abs(tvis5-tvis4).lt.1) then
          if((tvis5.ne.j).and.(id(tvis5,1).ne.j.and.
     >                             id(tvis5,2).ne.j)
     >      ) then
           tvis3=tvim1(tvis3,2)
           goto 5
          endif
          if(tvis5.ne.j) then
           tvds=tvds+(-.5d0*dinv_d(tvis5))**2
          else
           if(id(tvis5,1).ne.id(tvis5,2)) then
            tvds=tvds-.5d0*(dinv_d(tvis5)**2)
           else
            tvds=tvds-dinv_d(tvis5)**2
           endif
          endif
         endif
5        tvis2=tvim1(tvis2,2)
        enddo
        write(97,'(2i8,f16.8)') i,j,tvds

        tvis1=tvim1(tvis1,2)
       enddo
      enddo

c     -----------------------------------------

      do i=1,nr_ind
       id(i,1)=i  ! Here id is used for another purpose.
       tvim1(i,2)=0
      enddo

      rewind(97)
      i=1
      j=0
6     read(97,'(2i8,f16.8)',end=7) (tvim2(i,tvis1),tvis1=1,2)
     >                             ,tvdm(i)
      if(tvim2(i,1).ne.tvim2(i,2)) then
       j=j+1
       tvim1(id(tvim2(i,2),1),2)=nr_ind+j
       tvim1(nr_ind+j,1)=i
       tvim1(nr_ind+j,2)=0
       id(tvim2(i,2),1)=nr_ind+j
      endif
      i=i+1
      goto 6
7     continue

      rewind(97)
      tvis1=1
      do i=1,nr_ind
       nr_nze=0
       j=tvim1(i,2)
       do while(j.ne.0)
        if(abs(tvdm(tvim1(j,1))).gt.1.d-8) then
         write(97,'(2i8,f16.8)') (tvim2(tvim1(j,1),k)
     >                 ,k=2,1,-1),tvdm(tvim1(j,1))
         nr_nze=nr_nze+1
        endif
        j=tvim1(j,2)
       enddo
       do while(abs(tvim2(tvis1,1)-i).lt.1)
        if(abs(tvdm(tvis1)).gt.1.d-8) then
         write(97,'(2i8,f16.8)') (tvim2(tvis1,k),k=1,2)
     >                           ,tvdm(tvis1)
         nr_nze=nr_nze+1
        endif
        tvis1=tvis1+1
       enddo
       write(96,'(i8)') nr_nze
      enddo

      stop
      end
