      program phtp01

c     phtp01 replaces ID numbers in phtp_id.txt with
c     sequential numbers.

      include 'phtp01.inc'
      integer iv(3)
      real*8 rand

c     npp means 'not present in the pedigree'.

      open(99,file='pdgr_id.txt')
      open(98,file='phtp_id.txt')
      open(97,file='phtp.txt')
      open(96,file='phtp_npp.txt')

c     Data is read from pdgr_id.txt.

      nr_ind=1
1     read(99,*,end=2) (im(nr_ind,i),i=1,4)
      nr_ind=nr_ind+1
      goto 1
2     continue
      nr_ind=nr_ind-1

c     Each record is read from phtp_id.txt and its ID
c     number is replaced with a sequential number in im,
c     which has been found by binary search.

      nr_obs=0
3     read(98,*,end=4) (iv(i),i=1,3)
      i=1
      j=nr_ind+1
      do while(i.lt.j)
       k=(i+j)/2
       if(iv(1).eq.im(k,1)) then
        goto 5
       elseif(iv(1).gt.im(k,1)) then
        i=k+1
       else
        j=k
       endif
      enddo
5     continue
      if(iv(1).eq.im(k,1)) then
       nr_obs=nr_obs+1
       write(97,'(i10,2i8)') im(k,4),(iv(i),i=2,3)
      else
       write(96,'(i10,2i8)') (iv(i),i=1,3)
      endif
      goto 3
4     continue

c     -----------------------------------------

*     write(*,*) nr_ind,nr_obs
      rewind(97)
      i=0
      do j=1,nr_obs
       read(97,*) (im(j,k),k=1,3)
       call r_uni(rand,i)
       im(j,4)=int(mx_ind*rand)+1
      enddo

      call qsrt(4,1)
      call qsrt(1,0)

      rewind(97)
      do i=1,nr_obs
       write(97,'(i10,2i8)') (im(i,j),j=1,3)
      enddo

      stop
      end

c     ########################################

      subroutine qsrt(is1,is2)

      include 'phtp01.inc'
      integer pivot,n_feis(mx_ind),n_leis(mx_ind)

*     nr_ccl=0

      nr_sbv=1
      n_feis(1)=1
      n_leis(1)=nr_obs
      do i=2,nr_obs
       n_feis(i)=0
       n_leis(i)=0
      enddo

c     -----------------------------------------

      do while(nr_sbv.lt.nr_obs)
       nr_dsv=0  ! No. of divided subvectors
       do i=1,nr_sbv
        if(n_leis(i)-n_feis(i).lt.1) goto 3
        pivot=max(im(n_feis(i),is1),im(n_feis(i)+1,is1))

        is3=n_feis(i)
        is4=n_leis(i)
4       continue
        do while(im(is3,is1).lt.pivot.and.
     >           is3.lt.n_leis(i))
         is3=is3+1
        enddo
        do while(im(is4,is1).gt.pivot.and.
     >           is4.gt.n_feis(i))
         is4=is4-1
        enddo
        if(is3.lt.is4) then
         is5=im(is3,is1)
         im(is3,is1)=im(is4,is1)
         im(is4,is1)=is5
         if(is2.gt.0) then
          is5=im(is3,is2)
          im(is3,is2)=im(is4,is2)
          im(is4,is2)=is5
         endif
         do j=2,3
          is5=im(is3,j)
          im(is3,j)=im(is4,j)
          im(is4,j)=is5
         enddo

         is3=is3+1
         is4=is4-1
         goto 4
        else
         nr_dsv=nr_dsv+1
         n_leis(nr_sbv+nr_dsv)=n_leis(i)
         n_leis(i)=is3-1
         n_feis(nr_sbv+nr_dsv)=is3
        endif
3       continue
       enddo
       nr_sbv=nr_sbv+nr_dsv

*      if(nr_sbv.ge.nr_ccl) then
*       call gettim(ihr,imin,isec,i100th)
*       time2=60.d0*(60.d0*ihr+imin)+isec+i100th/100.d0
*       write(*,'(i10,f16.8)') nr_sbv,time2-time1
*       nr_ccl=nr_ccl+nr_itv
*      endif
      enddo

      return
      end

c     ########################################

      subroutine r_uni(z,tan)
      integer l,c,t30,tan
      real*8 mu,z
      parameter(l=843314861,c=453816693,t30=2**30,
     >          mu=2.0**31)

      tan=l*tan+c
      if(tan.lt.0) tan=(tan+t30)+t30
      z=dble(tan)/mu
      return
      end
