#! /usr/bin/perl

use strict;
use warnings;

$| = 1;

our $flg = 1;
our $EXIT = sub {
	#print "EXIT\n";
	#exit;
	$flg = 0;

	return ('close $fp', 'exit');
};


our $DRAW_PEDIGREE = sub {
	(my $w, my $unit, my @data) = @_;
	#print "DATA:$data\n";
	#print "W:$w\nDATA:".(join "\n", @data)."\n";

	my @header = ('Family', 'ID', 'Fid', 'Mid', 'Sex', 'Phenotype');
	my %num_of_header = map {$header[$_] => $_} (0 .. $#header);

	my %DATA;
	foreach (@data){
		undef my @strings;
		@strings = split /,/;

		%{$DATA{$strings[$num_of_header{'ID'}]}} = map {$_ => $strings[$num_of_header{$_}]} @header;
	}

	foreach my $id (keys %DATA){
		@{$DATA{$id}->{'CHILD'}} = ();
		@{$DATA{$id}->{'MARRIED'}} = ();
	}

	foreach my $id (keys %DATA){
		if(exists $DATA{$DATA{$id}->{'Fid'}}){
			push @{$DATA{$DATA{$id}->{'Fid'}}->{'CHILD'}}, $id;
		}
		if(exists $DATA{$DATA{$id}->{'Mid'}}){
			push @{$DATA{$DATA{$id}->{'Mid'}}->{'CHILD'}}, $id;
		}
	}

	foreach my $id (keys %DATA){
		foreach my $child (@{$DATA{$id}->{'CHILD'}}){
			my $tMarried = '';
			if($DATA{$child}->{'Fid'} ne $id and exists $DATA{$DATA{$child}->{'Fid'}}){
				$tMarried = $DATA{$child}->{'Fid'};
			}
			if($DATA{$child}->{'Mid'} ne $id and exists $DATA{$DATA{$child}->{'Mid'}}){
				$tMarried = $DATA{$child}->{'Mid'};
			}

			if($tMarried ne ''){
				if(scalar(grep {$_ eq $tMarried} @{$DATA{$id}->{'MARRIED'}}) == 0){
					push @{$DATA{$id}->{'MARRIED'}}, $tMarried;
				}
			}
		}
	}
	
#	foreach my $id (sort {$a <=> $b} keys %DATA){
#		print "CHILD:$id:".(join ',', @{$DATA{$id}->{'CHILD'}})."\n";
#	}
#	foreach my $id (sort {$a <=> $b} keys %DATA){
#		print "MARRIED:$id:".(join ',', @{$DATA{$id}->{'MARRIED'}})."\n";
#	}

	my %rest = map {$_ => 0} keys %DATA;
	while(scalar(keys %rest) > 0){
		my $flg = 0;
		foreach my $id (keys %rest){
			if(exists $DATA{$DATA{$id}->{'Fid'}} and exists $DATA{$DATA{$id}->{'Fid'}}->{'RANK'}){
				$DATA{$id}->{'RANK'} = $DATA{$DATA{$id}->{'Fid'}}->{'RANK'} + 1;
				delete $rest{$id};
				$flg = 1;
			}
			elsif(exists $DATA{$DATA{$id}->{'Mid'}} and exists $DATA{$DATA{$id}->{'Mid'}}->{'RANK'}){
				$DATA{$id}->{'RANK'} = $DATA{$DATA{$id}->{'Mid'}}->{'RANK'} + 1;
				delete $rest{$id};
				$flg = 1;
			}
			elsif(scalar(@{$DATA{$id}->{'CHILD'}}) > 0 && scalar(grep {exists $DATA{$_}->{'RANK'}} @{$DATA{$id}->{'CHILD'}}) > 0){
				foreach my $cid (@{$DATA{$id}->{'CHILD'}}){
					if(exists $DATA{$cid}->{'RANK'}){
						$DATA{$id}->{'RANK'} = $DATA{$cid}->{'RANK'} - 1;
						delete $rest{$id};
						$flg = 1;

						last;
					}
				}
			}
#			else{
#				$DATA{$id}->{'RANK'} = 0;
#				delete $rest{$id};
#				$flg = 1;
#			}
		}
		if($flg == 0 && scalar(keys %rest) > 0){
			my $id = (keys %rest)[0];
			my @founder = grep {$DATA{$_}->{'Fid'} cmp '0' and $DATA{$_}->{'Mid'} cmp '0'} keys %rest;
			if(scalar(@founder) == 0){
				my @sFounder = grep {$DATA{$_}->{'Fid'} cmp '0' or $DATA{$_}->{'Mid'} cmp '0'} keys %rest;
				if(scalar(@sFounder) > 0){
					$id = $sFounder[0];
				}
			}
			else{
				$id = $founder[0];
			}
			$DATA{$id}->{'RANK'} = 0;
			delete $rest{$id};
		}
	}

	my $min_rank = 0;
	foreach my $id (keys %DATA){
		my $tRank = $DATA{$id}->{'RANK'};
		if($tRank < $min_rank){
			$min_rank = $tRank;
		}
	}
	foreach my $id (keys %DATA){
		$DATA{$id}->{'RANK'} -= $min_rank;
	}

	my %RANK;
	foreach my $id (keys %DATA){
		unless(exists $RANK{$DATA{$id}->{'RANK'}}){
			@{$RANK{$DATA{$id}->{'RANK'}}} = ();
		}

		push @{$RANK{$DATA{$id}->{'RANK'}}} , $id;
		$DATA{$id}->{'POS'} = scalar(@{$RANK{$DATA{$id}->{'RANK'}}});
	}

	my %RD;
	foreach my $id (keys %RANK){
		$RD{$id} = scalar(@{$RANK{$id}});
	}

	my @rarray = sort {$a <=> $b} keys %RANK;
	for(my $i = 0; $i < scalar(@rarray); $i++){
		undef my @rest;
		@rest = map {$_} @{$RANK{$rarray[$i]}};

		undef my %dist;
		undef my %pos;
		my @null_array = ();
		&get_rank_pos_rec(\@rest, 0, \@null_array, \%dist, \%DATA, \%RD, $rarray[$i], \%pos);



#
#		undef my @digit;
#		for(my $j = 0; $j < @{$RANK{$rarray[$i]}}; $j++){
#			$digit[$j] = 0;
#		}
#		$digit[scalar(@{$RANK{$rarray[$i]}})] = -1;

#		undef my %dist;
#		while($digit[scalar(@{$RANK{$rarray[$i]}})] == -1){
#			my %dupli_digit = map {$_ => 0} @digit;
#			if(scalar(keys %dupli_digit) == scalar(@digit)){
#				my $d = 0;
#				undef my %pos;
#				for(my $k = 0; $k < @digit; $k++){
#					$digit[$k] == -1 or $pos{$RANK{$rarray[$i]}->[$digit[$k]]} = $k + 1;
#				}

#				foreach my $id (@{$RANK{$rarray[$i]}}){
#					if(exists $DATA{$DATA{$id}->{'Fid'}}){
#						#$d += abs($pos{$id} - $DATA{$DATA{$id}->{'Fid'}}->{'POS'});
#						#$d += abs($rarray[$i] - $DATA{$DATA{$id}->{'Fid'}}->{'RANK'});
#						$d += abs($pos{$id} / $RD{$rarray[$i]} - $DATA{$DATA{$id}->{'Fid'}}->{'POS'} / $RD{$DATA{$DATA{$id}->{'Fid'}}->{'RANK'}});
#						$d += abs($rarray[$i] - $DATA{$DATA{$id}->{'Fid'}}->{'RANK'});
#					}
#					if(exists $DATA{$DATA{$id}->{'Mid'}}){
#						$d += abs($pos{$id} / $RD{$rarray[$i]} - $DATA{$DATA{$id}->{'Mid'}}->{'POS'} / $RD{$DATA{$DATA{$id}->{'Mid'}}->{'RANK'}});
#						$d += abs($rarray[$i] - $DATA{$DATA{$id}->{'Mid'}}->{'RANK'});
#					}
#					foreach my $mId (@{$DATA{$id}->{'MARRIED'}}){
#						$d += abs($pos{$id} / $RD{$rarray[$i]} - $pos{$mId} / $RD{$DATA{$mId}->{'RANK'}});
#						$d += abs($rarray[$i] - $DATA{$mId}->{'RANK'});
#					}
##					foreach my $cId (@{$DATA{$id}->{'CHILD'}}){
##						$d += abs($pos{$id} - $DATA{$cId}->{'POS'});
##						$d += abs($rarray[$i] - $DATA{$cId}->{'RANK'});
##					}
#				}

#				$dist{(join ',', @digit)} = $d;
#			}

#			my $k = 0;
#			$digit[$k]++;
#			while($digit[$k] >= scalar(@{$RANK{$rarray[$i]}})){
#				$digit[$k] = 0;
#				$k++;
#				$digit[$k]++;
#			}
#		}

		undef my @max_digit;
		@max_digit = split /,/, (sort {$dist{$a} <=> $dist{$b}} keys %dist)[0];
#		splice @max_digit, -1, 1;

		for(my $j = 0; $j < @max_digit; $j++){
			#$DATA{$RANK{$rarray[$i]}->[$max_digit[$j]]}->{'POS'} = $j + 1;
			$DATA{$max_digit[$j]}->{'POS'} = $j + 1;
		}
	}

	my $max_num = 0;
	foreach my $r (keys %RANK){
		my $tNum = scalar(@{$RANK{$r}});
		if($tNum > $max_num){
			$max_num = $tNum;
		}
	}

	my %married_array = ();
	my %child_array = ();
	foreach my $id (keys %DATA){
		foreach my $mId (@{$DATA{$id}->{'MARRIED'}}){
			my $tMarried = join '--', sort {$a cmp $b} ($id, $mId);
			unless(exists $married_array{$tMarried}){
				$married_array{$tMarried} = 0;

				if(scalar(@{$DATA{$id}->{'CHILD'}}) != 0){
					my $tChild = join '--', sort {$a cmp $b} @{$DATA{$id}->{'CHILD'}};
					my $tFamily = join '==', ($tMarried, $tChild);

					unless(exists $child_array{$tFamily}){
						$child_array{$tFamily} = 0;
					}
				}
			}
		}
	}
	my $set_married = 'set MARRIED {'.(join ' ', map {'{'.(join ' ', split /--/).'}'} keys %married_array).'}';
	my $set_family = 'set NUC_FAMILY {{'.(join '} {', map {'{'.(join '} {', map {join ' ', split /--/} split /==/).'}'} keys %child_array).'}}';
	#print "puts {".$set_married."}\n";
	#print "puts {".$set_family."}\n";

	my @str;
	#my $unit = 15;
	my @init = (10, 50);
	my $radius = 1;
	my $obj_span_width = 7;
	my $obj_span_height = 8;

#	push @str, 'set unit '.$unit;
#	push @str, 'set init {'.(join ' ', @init).'}';
#	push @str, 'set radius '.$radius;
#	push @str, 'set obj_span_width '.$obj_span_width;
#	push @str, 'set obj_span_height '.$obj_span_height;

	my $ocnt = 0;
	foreach my $id (keys %DATA){
		my $obj_id = 'OBJ_'.$id;
		my $txt_id = 'TXT_'.$id;
		my $dav_id = 'DAV_'.$id;
		my $Fid = $DATA{$id}->{'Fid'};
		my $Mid = $DATA{$id}->{'Mid'};
		my $sex = $DATA{$id}->{'Sex'};
		my $phn = $DATA{$id}->{'Phenotype'};

		my $rank = $DATA{$id}->{'RANK'};
		my $pos = $DATA{$id}->{'POS'};
		my $width = $max_num / (scalar(@{$RANK{$rank}}) + 1);

		my @center = ($init[0] + $obj_span_width * $unit * $pos * $width, $init[1] + $obj_span_height * $rank * $unit);
		my @left = ($center[0] - $radius * $unit, $center[1] - $radius * $unit);
		my @right = ($center[0] + $radius * $unit, $center[1] + $radius * $unit);
		my $com = 'set '.$obj_id." [$w create ".($sex == 2 ? 'oval ' : 'rectangle ').(join ' ', @left).' '.(join ' ', @right).($phn == 2 ? ' -fill black' : ' -fill white').' -tags {SAMPLE_'.$obj_id.' DELETE_OBJ}]';
		push @str, $com;
		$com = 'set '.$txt_id." [$w create text ".(join ' ', @center).' -text '.$id.' -fill '.($phn == 2 ? 'white' : 'black').' -tags {SAMPLE_'.$txt_id.' DELETE_OBJ}]';
		push @str, $com;
		@left = ($center[0] - $radius * $unit * sqrt(2.0), $center[1] + $radius * $unit * sqrt(2.0));
		@right = ($center[0] + $radius * $unit * sqrt(2.0), $center[1] - $radius * $unit * sqrt(2.0));
		$com = 'set '.$dav_id." [$w create line @{[join ' ', @left]} @{[join ' ', @right]} -width 3 -tags {SAMPLE_${dav_id} DELETE_OBJ} -state hidden]";
		push @str, $com;

		$ocnt++;
	}
	my $command = join "\n", @str;
	#print "COM:$command\n";


	my $ret = <<"RET";
overwrite_message .eMessage {DRAW pedigree at $w}

$w delete {DELETE_OBJ}
$command
$set_family
put_family_line $w \$NUC_FAMILY
RET

	return split /\n/, $ret;
};


our $CALCULATE_ALL = sub {
	(my $target, my $bhw, my $hw, my $lhw, my $bw, my $w, my $lw, my $cw, my $p_NN, my $p_NS, my $p_SS, my $risk_allele_freq, my @data)= @_;
	
	my $calc_gen_dir = 'PAPn03d';

	my $in_ped_file = 'tmp_ped'.$$.'.ped';
	my $in_gen_file = 'tmp_gen'.$$.'.csv';
	my $in_pen_file = 'tmp_pen'.$$.'.csv';

	my @available_num = ();
	my @sample_id = ();

	open OUT, ">$in_ped_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN PED FILE}';
	print OUT ''.(join "\n",map {my @tmp = split /,/; push @available_num, shift @tmp; push @sample_id, $tmp[1]; join ',', @tmp} @data)."\n";
	close OUT;
	
	undef my @in_data;
	undef my @sample_name;
	my $sample_num = 0;
	if(open IN, "$in_ped_file"){
		while(<IN>){
			s/[\r\n]//g;
			undef my @strings;
			@strings = split /,/;
			
			for(my $i = 0; $i < @strings; $i++){
				$in_data[$sample_num]->[$i] = $strings[$i];
			}

			$sample_name[($sample_num + 1)] = $in_data[$sample_num]->[1];
			$in_data[$sample_num]->[1] = $sample_num + 1;
			$sample_num++;
		}
	}

	my $c_pdgr_unc = $calc_gen_dir.'/pdgr_uncompleted.txt';
	my $c_phtp_id = $calc_gen_dir.'/phtp_id.txt';
	my $c_out_file = $calc_gen_dir.'/outp2.txt';
	my $c_id_file = $calc_gen_dir.'/pdgr_id.txt';
	
	if(open OUT, ">$c_pdgr_unc"){
		my @ar = (1, 2, 3);
		for(my $i = 0; $i < $sample_num; $i++){
			foreach my $n (@ar){
				print OUT " $in_data[$i]->[$n]";
			}
			print OUT "\n";
		}
		
		close OUT;
	}
	
	if(open OUT, ">$c_phtp_id"){
		my @ar = (1, 4, 5);
		for(my $i = 0; $i < $sample_num; $i++){
			$in_data[$i]->[4]--;
			$in_data[$i]->[5]--;
			foreach my $n (@ar){
				print OUT " ".($in_data[$i]->[$n]);
			}
			print OUT "\n";
		}
		
		close OUT;
	}
	
	my $command = "scripts\\PAPn03d.bat >NUL 2>&1";
	my $sysRes = system $command;
	
	undef my %tr_ar;
	if(open IN, "$c_id_file"){
		while(<IN>){
			s/[\r\n]//g;
			undef my @strings;
			@strings = split /\s+/;
			
			#$tr_ar{$strings[4]} = $strings[1];
			$tr_ar{$strings[4]} = $sample_name[$strings[1]];
		}
	
		close IN;
	}
	
	undef my @IDs;
	@IDs = map {$tr_ar{$_}} sort {$a <=> $b} keys %tr_ar;

	#open IN, "../gtpp1_2.txt" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	open IN, "$c_out_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	open OUT, ">$in_gen_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	print OUT "ID,AA,AB,BB\n";
	my $i = 0;
	my @dammy = ();
	my $flg = 0;
	my $gf_sig = 0.9;
	while(<IN>){
		#print OUT "$_";
		s/[\r\n]//g;
		undef my @strings;
		@strings = split /\s+/;
		$strings[0] = shift @IDs;
		#$strings[0] = $sample_id[shift @IDs];
		
		my $gf_sig_flg = 0;
		for(my $k = 1; $k < @strings; $k++){
			$strings[$k] > 0.9 and $gf_sig_flg = $k;
		}
		unless($gf_sig_flg == 0){
			for(my $k = 1; $k < @strings; $k++){
				$strings[$k] = 0;
			}
			
			$strings[$gf_sig_flg] = 1.0;
		}
		
		print OUT "".(join ',', @strings)."\n";
		
		if(defined $available_num[$i]){
			my $el_num = $available_num[$i];
			push @dammy, ".eGAA_".$el_num." delete 0 end";
			push @dammy, ".eGAB_".$el_num." delete 0 end";
			push @dammy, ".eGBB_".$el_num." delete 0 end";
			push @dammy, ".eGAA_".$el_num." insert 0 ".(sprintf $strings[1] == 0 ? '0' : $strings[1] < 0.001 ? "%.3e" : "%.4f", $strings[1])."\n.eGAB_".$el_num." insert 0 ".(sprintf $strings[2] == 0 ? '0' : $strings[2] < 0.001 ? "%.3e" : "%.4f", $strings[2])."\n.eGBB_".$el_num." insert 0 ".(sprintf $strings[3] == 0 ? '0' : $strings[3] < 0.001 ? "%.3e" : "%.4f", $strings[3] + 0)."\n";
			$i++;
		}
	}
	my $DAMMY = ''.(join "\n", @dammy)."\n";
	close OUT;
	close IN;

	open OUT, ">$in_pen_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN PENETRANCE FILE}';
	print OUT ''.(join "\n", ((join ",", ('SS', 'NS', 'NN')), (join ",", ($p_SS, $p_NS, $p_NN))))."\n";
	close OUT;

	my $result = '';
	if($target eq 'All'){
		$command = 'bin\\fast_link.exe '.$in_ped_file.' '.$in_gen_file.' '.$in_pen_file.' '.$risk_allele_freq;
		$result = (split /\n/, (split /LOD score:/, `$command`)[1])[0];
	}
	elsif($target eq 'Selective'){
		$command = 'bin\\fast_link.exe '.$in_ped_file.' '.$in_gen_file.' '.$in_pen_file.' '.$risk_allele_freq.' ORDER';
		$result = (split /\[ORDER\]/, `$command`)[1];
	}

	my @size = ();
	my @header_widget = ();
	push @header_widget, 'label .lheader_NUM -text {NUM} -width {4} -relief solid';
	for($i = 0; $i < @sample_id; $i++){
		#push @size, scalar(split //, $sample_id[$i]) + 1;
		push @size, length($sample_id[$i]) + 1;

		push @header_widget, 'label .lheader_'.$sample_id[$i].' -text {'.$sample_id[$i].'} -width {'.$size[$i].'} -relief solid';
	}
	push @header_widget, 'label .lheader_VALUE -text {LODscore} -width {8} -relief solid';
	push @header_widget, 'label .lheader_ODDS -text {ODDS} -width {8} -relief solid';

	#my $header_out = ''.(join "\n", map {"$hw window create end -window [$_]"} @header_widget)."\n"."$w insert end \"\\n\"";
	my $header_out = "$bhw configure -state normal\n$bhw delete 0.0 end\n".(join "\n", map {"$bhw window create end -window [$_]"} shift @header_widget)."\n"."$bhw configure -state disabled\n";
	my @wtmp = ();#$header_widget[-2 .. -1];
	map {unshift @wtmp, pop @header_widget} (1 .. 2);
	$header_out .= "$hw configure -state normal\n$hw delete 0.0 end\n".(join "\n", map {"$hw window create end -window [$_]"} @header_widget)."\n"."$hw configure -state disabled\n";
	$header_out .= "$lhw configure -state normal\n$lhw delete 0.0 end\n".(join "\n", map {"$lhw window create end -window [$_]"} @wtmp)."\n"."$lhw configure -state disabled\n";

	my @out_data = ("$w configure -state normal", "$w delete 0.0 end");
	if(defined $result){
		undef my @lines;
		if($target eq 'All'){
			#$lines[0] = join ' ', ($result, '('.(join ',', map {$tr_ar{$_}} sort {$tr_ar{$a} <=> $tr_ar{$b}} keys %tr_ar).')');
			$lines[0] = join ' ', ($result, '('.(join ',', map {$sample_name[$_]} (1 .. $#sample_name)).')');
		}
		elsif($target eq 'Selective'){
			@lines = split /\n/, $result;
			shift @lines;
		}
		my $cnt = 1;
		foreach my $line (@lines){
			my $LOD_score = (split / /, $line)[0];
			(my $avail) = $line =~ /(\(.+\))/;
			(my $disavail) = $line =~ /(\[.+\])/;
			(my $odds) = $line =~ /(\{.+\})/;

			#defined $avail and $avail =~ s/[\(\)]//g;
			#defined $disavail and $disavail =~ s/[\[\]]//g;
			#defined $odds and $odds =~ s/[\{\}]//g;

			defined $avail or $avail = '';
			defined $disavail or $disavail = '';
			defined $odds or $odds = '';

			$avail =~ s/[\(\)]//g;
			$disavail =~ s/[\[\]]//g;
			$odds =~ s/[\{\}]//g;

			#push @out_data, join '+', ($LOD_score, (join ' ', split /,/, $avail), (join ' ', split /,/, $disavail), $odds);
			push @out_data, "$bw window create end -window [label .lNUM_$cnt -text {$cnt} -width {4} -relief raised]";
			push @out_data, "$bw insert end \"\\n\"";
			push @out_data, 'bind .lNUM_'.$cnt.' <ButtonPress-1> "[list set_missed_pedigree '.$bw.' '.$w.' '.$lw.' '.$cw.' '.$cnt.' {'.(join ' ', split /,/, $avail).'} {'.(join ' ', split /,/, $disavail).'}]"';
			for($i = 0; $i < @sample_id; $i++){
				push @out_data, "$w window create end -window [label .lFLAG_".$cnt."_".$i." -text {".(scalar(grep {$_ eq $sample_id[$i]} split /,/, $avail) != 0 ? 'O' : 'X')."} -width {".$size[$i]."} -relief groove]";
			}
			push @out_data, "$w insert end \"\\n\"";
			push @out_data, "$lw window create end -window [label .lLOD_$cnt -text {".(sprintf $LOD_score eq '' ? "%s" : $LOD_score < 0.001 ? "%.3e" : "%.4f", $LOD_score)."} -width {8} -relief groove]";
			push @out_data, "$lw window create end -window [label .lODDS_$cnt -text {".(sprintf $odds eq '' ? "%s" : $odds < 0.001 ? "%.3e" : "%.4f", $odds)."} -width {8} -relief groove]";
			push @out_data, "$lw insert end \"\\n\"";

			$cnt++;
		}
	}
	push @out_data, "$w configure -state disabled";
	#my $return_data = ''.(join "\n", map {"$w ".'insert end "'.$_.'\n"'} @out_data);
	my $result_out = ''.(join "\n", @out_data);

	map {unlink $_} ($in_ped_file, $in_gen_file, $in_pen_file);



	my $ret = <<"RET";
overwrite_message .eMessage {Calculate ALL at $w : BAT $sysRes}

$DAMMY
$bhw delete 0.0 end
$lhw delete 0.0 end
$hw delete 0.0 end
$bw delete 0.0 end
$lw delete 0.0 end
$w delete 0.0 end

$header_out
$result_out

RET

###DEBUGED IN HERE DOCUMENT {RET}###
#$w insert end {$command}
#$w insert end \\n
#$return_data

#puts bhw:$bhw
#puts hw:$hw
#puts bw:$bw
#puts w:$w

###DEBUGED IN HERE DOCUMENT {RET}###

#$ret .= ''.(join "\n", map {"$w insert end {$_}\n$w insert end ".'"\n"'} split /\n/, $result)."\n";

	return split /\n/, $ret;
};


our $INFILE = sub {
	my ($in_file_path, $wMessage) = @_;
	my $flg = 'OK';

	if(open IN, "$in_file_path"){
		my @header = ('Family', 'ID', 'Fid', 'Mid', 'Sex', 'Phenotype');
		my %num_of_header = map {$header[$_] => $_} (0 .. $#header);
		my @data = ();
		my @fRow = ();
		my @fEle = ();
		my $row = 1;
		while(<IN>){
			s/[\r\n]//g;
			my @strings = ();
			@strings = split /[,\s]/;

			if(scalar(@strings) < 6){
				push @fRow, "$row(".(scalar(@strings)).")";
			}

			foreach my $head ('Sex', 'Phenotype'){
				my $val = $strings[$num_of_header{$head}];
				unless($val eq '1' or $val eq '2' or $val eq '0'){
					push @fEle, (join '-', ($row, $num_of_header{$head}));
				}
			}

			$row++;
		}
		close IN;

		if(scalar(@fRow) > 0){
			$flg = 'NG:number of elements( '.(join ',', map {'Row-'.$_} @fRow).' )';
		}
		elsif(scalar(@fEle) > 0){
			$flg = 'NG:element( '.(join ', ', map {'Row-'.(join '/Col-', split /-/)} @fEle).' )';
		}
	}
	else{
		$flg = '"'.$in_file_path.'" does not exist.';
	}

	my $ret = <<"RET";
overwrite_message .eMessage {Check FileInput}

$wMessage configure -text {$flg}

RET

	return split /\n/, $ret;
};


our $CALC_MINI = sub {
	my ($in_file, $p_SS, $p_NS, $p_NN, $risk_allele_freq, $wResult) = @_;
	
	my $calc_gen_dir = 'PAPn03d';

	my $in_ped_file = 'tmp_ped'.$$.'.csv';
	my $in_gen_file = 'tmp_gen'.$$.'.csv';
	my $in_pen_file = 'tmp_pen'.$$.'.csv';

	my @available_num = ();
	my @sample_id = ();

	undef my @in_data;
	undef my @sample_name;
	my $sample_num = 0;
	undef my @ped_out;
	if(open IN, "$in_file"){
		while(<IN>){
			s/[\r\n]//g;
			undef my @strings;
			@strings = split /[,\t\s]/;
			push @ped_out, (join ',', @strings);
			
			for(my $i = 0; $i < @strings; $i++){
				$in_data[$sample_num]->[$i] = $strings[$i];
			}

			$sample_name[($sample_num + 1)] = $in_data[$sample_num]->[1];
			$in_data[$sample_num]->[1] = $sample_num + 1;
			$sample_num++;
		}
	}
	
	open OUT, ">$in_ped_file" or return split /\n/, 'overwrite_message .eMessage {ERROR MAKE PED FILE}';
	print OUT (join "\n", @ped_out)."\n";
	close OUT;

	my $c_pdgr_unc = $calc_gen_dir.'/pdgr_uncompleted.txt';
	my $c_phtp_id = $calc_gen_dir.'/phtp_id.txt';
	my $c_out_file = $calc_gen_dir.'/outp2.txt';
	my $c_id_file = $calc_gen_dir.'/pdgr_id.txt';
	
	if(open OUT, ">$c_pdgr_unc"){
		my @ar = (1, 2, 3);
		for(my $i = 0; $i < $sample_num; $i++){
			foreach my $n (@ar){
				print OUT " $in_data[$i]->[$n]";
			}
			print OUT "\n";
		}
		
		close OUT;
	}
	
	if(open OUT, ">$c_phtp_id"){
		my @ar = (1, 4, 5);
		for(my $i = 0; $i < $sample_num; $i++){
			$in_data[$i]->[4]--;
			$in_data[$i]->[5]--;
			foreach my $n (@ar){
				print OUT " ".($in_data[$i]->[$n]);
			}
			print OUT "\n";
		}
		
		close OUT;
	}
	
	my $command = "script\\PAPn03d.bat >NUL 2>&1";
	my $sysRes = system $command;
	
	undef my %tr_ar;
	if(open IN, "$c_id_file"){
		while(<IN>){
			s/[\r\n]//g;
			undef my @strings;
			@strings = split /\s+/;
			
			#$tr_ar{$strings[4]} = $strings[1];
			$tr_ar{$strings[4]} = $sample_name[$strings[1]];
		}
	
		close IN;
	}
	
	undef my @IDs;
	@IDs = map {$tr_ar{$_}} sort {$a <=> $b} keys %tr_ar;

	#open IN, "../gtpp1_2.txt" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	open IN, "$c_out_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	open OUT, ">$in_gen_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN GEN FILE}';
	print OUT "ID,AA,AB,BB\n";
	my $i = 0;
	my @dammy = ();
	my $flg = 0;
	my $gf_sig = 0.9;
	while(<IN>){
		#print OUT "$_";
		s/[\r\n]//g;
		undef my @strings;
		@strings = split /\s+/;
		$strings[0] = shift @IDs;
		#$strings[0] = $sample_id[shift @IDs];
		
		my $gf_sig_flg = 0;
		for(my $k = 1; $k < @strings; $k++){
			$strings[$k] > 0.9 and $gf_sig_flg = $k;
		}
		unless($gf_sig_flg == 0){
			for(my $k = 1; $k < @strings; $k++){
				$strings[$k] = 0;
			}
			
			$strings[$gf_sig_flg] = 1.0;
		}
		
		print OUT "".(join ',', @strings)."\n";
	}
	my $DAMMY = ''.(join "\n", @dammy)."\n";
	close OUT;
	close IN;

	open OUT, ">$in_pen_file" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN PENETRANCE FILE}';
	print OUT ''.(join "\n", ((join ",", ('SS', 'NS', 'NN')), (join ",", ($p_SS, $p_NS, $p_NN))))."\n";
	close OUT;

	my $result = '';
	$command = 'bin\\fast_link.exe '.$in_ped_file.' '.$in_gen_file.' '.$in_pen_file.' '.$risk_allele_freq;
	$result = (split /\n/, (split /LOD score:/, `$command`)[1])[0];
#	my $command = 'DEBUG';
#	my $result = 1.5;

	map {unlink $_} ($in_ped_file, $in_gen_file, $in_pen_file);

	my $ret = <<"RET";
overwrite_message .eMessage {Calculate CALC_MINI : $command}

set_ro_entry_value $wResult $result

RET

	return split /\n/, $ret;
};


our $SAVE = sub {
	my ($ped_file_name, @data) = @_;

	$ped_file_name =~ s/=sp=/ /g;

	my @available_num = ();
	my @sample_id = ();

	open OUT, ">$ped_file_name" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN PED FILE('.$ped_file_name.'):'.$!.'}';
	print OUT ''.(join "\n",map {my @tmp = split /,/; push @available_num, shift @tmp; push @sample_id, $tmp[1]; join "\t", @tmp} @data)."\n";
	close OUT;

	my $ret = <<"RET";
overwrite_message .eMessage {Save as $ped_file_name}
RET

	return split /\n/, $ret;
};


our $LOAD = sub {
	my ($ped_file_name, @wgt) = @_;

	$ped_file_name =~ s/=sp=/ /g;

	my @data = ();
	my $max_sample = 0;
	open IN, "$ped_file_name" or return split /\n/, 'overwrite_message .eMessage {ERROR OPEN PED FILE('.$ped_file_name.'):'.$!.'}';
	while(<IN>){
		s/[\r\n]//g;
		my @strings = ();
		@strings = split /[,\t]/;

		push @{$data[$max_sample]}, map {$_ == 4 ? $strings[$_] == 1 ? 'M' : $strings[$_] == 2 ?  'F' : '' : $_ == 5 ? $strings[$_] == 2 ? 'A' : $strings[$_] == 1 ? 'U': '' : $strings[$_]} (0 .. $#strings);
		$max_sample++;
	}
	close IN;

	my @twgt = ();
	my $max_wgt = 0;
	foreach my $w (@wgt){
		push @{$twgt[$max_wgt]}, map {$_} split /,/, $w;
		$max_wgt++;
	}

	my @out_wgt = ();
	for(my $i = 0; $i < $max_wgt; $i++){
		foreach my $w (@{$twgt[$i]}){
			if($w =~ /Sex/ or $w =~ /Phenotype/){
				push @out_wgt, "$w configure -state {normal}"
			}
			push @out_wgt, "$w delete 0 end";
			if($w =~ /Sex/ or $w =~ /Phenotype/){
				push @out_wgt, "$w configure -state {readonly}"
			}
		}
	}

	for(my $i = 0; $i < $max_sample and $i < $max_wgt; $i++){
		for(my $j = 0; $j < @{$twgt[$i]} ;$j++){
			if($j >= 4){
				push @out_wgt, "$twgt[$i]->[$j] configure -state {normal}"
			}
			push @out_wgt, "$twgt[$i]->[$j] insert 0 {$data[$i]->[$j]}";
			if($j >= 4){
				push @out_wgt, "$twgt[$i]->[$j] configure -state {readonly}"
			}
		}
	}

	my $ret = <<"RET";
overwrite_message .eMessage {Load from $ped_file_name}

@{[join "\n", @out_wgt]}
RET

	return split /\n/, $ret;
};


our $PROJECT = sub {
	(my $pw) = @_;

	#my @name = ('Project_a', '{Project b}', 'project,c');
	#map {push @name, "pj_d_$_"} (0 .. 10);
	#my @date = ('2013-05-21', '2013-06-04', '2013-06-17');
	#map {push @date, "2013-07-".(scalar(split //) == 1 ? '0' : '')."$_"} (0 .. 10);

	my $tdir = 'project/*.csv';
	my @files = glob $tdir;

	my @name;
	my @date;
	foreach my $file_name (@files){
		$file_name =~ s/\.csv//;
		my @suf = split /_/, $file_name;

		push @date, pop @suf;
		my $tmp = join '_', @suf;
		my @tmp = split /\//, $tmp;
		shift @tmp;
		push @name, join '/', @tmp;
		#push @name, join '_', @suf;
	}

	my $ret = <<"RET";
overwrite_message .eMessage {PROJECT}

global pw
set pw [project_screen \"\$pw\" {@name} {@date}]
RET

	return split /\n/, $ret;
};


my @arg = ();

print "OK\n";
print "DATAEOF\n";
while(<STDIN>){
	s/[\r\n]//g;
	$_ eq '' and next;

	if($_ eq 'DATAEOF'){
		my @ret = ();

		#print "ARG:".(scalar(@arg))."\n".(join "\n", @arg)."\n";
		if(scalar(@arg) != 0){
			my $fn = shift @arg;
			{
				no strict;
				defined ${$fn} and @ret = &${$fn}(@arg);
#				if(defined ${$fn}){
#					@ret = &${$fn}(@arg);
#				}
#				else{
#					@ret = ($fn, @arg);
#				}
			}
		}
		else{
			@ret = ('.eMessage delete 0 end', '.eMessage insert 0 {No Message}');
		}

		my $out = ''.(join "\n", @ret)."\n".'DATAEOF';
		print "$out\n";

		undef @arg;
	}
	else{
		push @arg, $_;
	}

	$flg or last;
}

#print "EXIT\nDATAEOF\n";


sub get_rank_pos_rec{
	my ($rest_h, $tval, $tkey_h, $dist_h, $DATA_h, $RD_h, $RANK, $pos_h) = @_;

	my @rest = @$rest_h;#print 'REC:'.(join ',', @rest)."\n";
	my @tkey = @$tkey_h;
	#my %dist = %$dist_h;
	if(scalar(@rest) == 0){
		$$dist_h{(join ',', @tkey)} = $tval;

		return;
	}

	my %DATA = %$DATA_h;
	my %RD = %$RD_h;
	my %pos = %$pos_h;

	foreach my $id (@rest){
		$pos{$id} = scalar(@tkey) + 1;
		my $d = $tval;
		if(exists $DATA{$DATA{$id}->{'Fid'}}){
			$d += abs($pos{$id} / $RD{$RANK} - $DATA{$DATA{$id}->{'Fid'}}->{'POS'} / $RD{$DATA{$DATA{$id}->{'Fid'}}->{'RANK'}});
			$d += abs($RANK - $DATA{$DATA{$id}->{'Fid'}}->{'RANK'});
		}
		if(exists $DATA{$DATA{$id}->{'Mid'}}){
			$d += abs($pos{$id} / $RD{$RANK} - $DATA{$DATA{$id}->{'Mid'}}->{'POS'} / $RD{$DATA{$DATA{$id}->{'Mid'}}->{'RANK'}});
			$d += abs($RANK - $DATA{$DATA{$id}->{'Mid'}}->{'RANK'});
		}
		foreach my $tId (@{$DATA{$id}->{'MARRIED'}}){
			foreach my $mId (grep {$tId eq $_} @tkey){
				$d += 2 * abs($pos{$id} / $RD{$RANK} - $pos{$mId} / $RD{$DATA{$mId}->{'RANK'}});
				$d += 2 * abs($RANK - $DATA{$mId}->{'RANK'});
			}
		}
				
		my @nRest = grep {$_ ne $id} @rest;#print 'REST:'.(join ',', @nRest)."\n";
		my @nKey = grep {$_ ne ''} (@tkey, $id);#print 'KEY:'.(join ',', @nKey)."\n";
		&get_rank_pos_rec(\@nRest, $d, \@nKey, \%$dist_h, \%DATA, \%RD, $RANK, \%pos);
	}

	return;
}
		

