/***
 *Header File of the Model for fsst_linkage.
 *@author Ryo TAKEMUTA
 *@date 20130819
 */


char ALLELE[2] = {'A', 'B'};
char PALLELE[2] = {'N', 'S'};

typedef struct FD{
	char *id;
	struct FD *next;
	struct FD *Fid;
	struct FD *Mid;
	int max_childs;
	int num_of_childs;
	struct FD **childs;

	int dip;

	double GENOTYPE[3];
	int PHENOTYPE;
	int SEX;

	double calculate[3][3];

	double part_likelihood;
} FAMILY_DATA;


typedef struct diplo {
	FAMILY_DATA *data;

	int G;
	int P;
	int D[2][2];
} DIP;


typedef struct ind_array {
	int *data;
	int number;
} ADATA;


typedef struct result_array {
	double *result;
	int max;
} RDATA;


typedef struct sort_array {
	struct sort_array *next;

	double LOD_score;
	char **element;
	int num_of_element;
	char **exclude_element;

	int num_of_exclude;
	unsigned long exclude;
} SDATA;


typedef struct result_lod {
	double LOD_score;

	double alt;
	double null;
} RLOD;


typedef struct result_linkage {
	struct result_linkage *next;

	double rf;//Recombination Fraction
	struct result_lod LOD;
} LINKAGE;


typedef struct linkaget_stack_child {
	int id;
	int Fid;
	int Mid;

	int fv[2];
	int mv[2];
	int flimit[2];
	int mlimit[2];
	double frcomb[2];
	double mrcomb[2];
	int dammy_g[2];
	int dammy_p[2];
	double rc;

	double elv;
	double telv;
	double ttelv[2];
} LCHDSTACK;


typedef struct linkage_stack_founder {
	int id;
	double ttelv;
	double telv;
	double elv;

	int i;
	int j;
} LFNDSTACK;


